#include <stdio.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/signal.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <syslog.h>
#include <libc.h>
#include <pwd.h>

/* ARGSUSED */
main(argc, argv)
int argc;
char *argv[];
{
	int i, p, t;
	char Sarg[8];
	char line[32];
	long WindowId;
	struct sgttyb b;
	char display[128];
	char *xterm, *xlogin, *xtools;
	uid_t getuid();
	char *pathof();
	int debug = 0;

	if (argc > 1 && strcmp(argv[1], "-debug") == 0) {
		debug++;
		argc--;
		argv++;
		for (i = getdtablesize()-1; i >= 0; i--)
			(void) close(i);
		t = open("/dev/tty", O_RDWR);
		if (t >= 0) {
			(void) ioctl(t, TIOCNOTTY, 0);
			(void) close(t);
		}
	}
	if (getuid() != 0 && !debug)
		exit(1);
	if (argc < 2)
		exit(2);
	(void) sprintf(line, "/dev/%s", argv[--argc]);
	argv[argc] = NULL;
	(void) strcpy(display, argv[--argc]);
	argv[argc] = NULL;
	if (strcmp(argv[argc-1],"-display") == 0)
	    argv[--argc]=NULL;
	xlogin = pathof("xconsole.xlogin");
	if (xlogin == NULL)
		exit(2);
	xtools = pathof("xconsole.xtools");
	if (xtools == NULL)
		exit(2);
	xterm = pathof("xconsole.xterm");
	if (xterm == NULL)
		exit(2);
	line[5] = 'p';
	p = open(line, O_RDWR, 0);
	if (p < 0)
		exit(3);
	if (p != 3) {
		(void) dup2(p, 3);
		(void) close(p);
		p = 3;
	}
	line[5] = 't';
	(void) chown(line, 0, 0);
	(void) chmod(line, 0622);
	if (open(line, O_RDWR, 0) < 0)
		exit(4);
	(void) signal(SIGHUP, SIG_IGN);
	vhangup();
	(void) setpgrp(0, 0);
	(void) signal(SIGHUP, SIG_DFL);
	(void) close(0);
	(void) open(line, O_RDWR, 0);
	(void) dup2(0, 1);
	(void) dup2(0, 2);
	if ((i = fork()) < 0)
		exit(5);
	if (i == 0) {
		(void) close(0);
		(void) open("/tmp/null", O_RDWR, 0);
		(void) dup2(0, 1);
		(void) dup2(0, 2);
		(void) sprintf(Sarg, "-S%c%c3", line[8], line[9]);
		execl(xterm, "xterm", Sarg, "-display", display,
			argv[1], argv[2], argv[3], argv[4], 0);
		exit(6);
		/*NOTREACHED*/
	}
	if (read(0, (char *)&WindowId, sizeof(WindowId)) != sizeof(WindowId))
		exit(7);
	(void) ioctl(0, TIOCGETP, (char *)&b);
	b.sg_flags = CRMOD|XTABS|ANYP|ECHO;
	(void) ioctl(0, TIOCSETP, (char *)&b);
	(void) close(p);
	run(xlogin, "xlogin", "-display", display, 0);
	kill(i, SIGINT);
  	execl(xtools, "xtools", "-geom", "=-1+1", "-file", "/dev/null", "-display", display, 0);
	exit(8);
	/*NOTREACHED*/
}
