#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <pwd.h>
#include <libc.h>
#include <c.h>


main(argc, argv)
int argc;
char *argv[];
{
    char buff[80], hostbuff[80], userbuff[80], dispbuff[80];
    char myhost[80];
    char *progname;
    char *host, *user, *display, *port;
    int s;
    FILE *f;
    struct hostent *hp;
    struct passwd *pw;
    struct servent *sp;
    struct sockaddr_in sin;
    int c, lastc;
    char *xhost, *pathof();
    uid_t getuid();
    u_long inet_addr();

    progname = *argv++; argc--;
    gethostname(myhost, sizeof(myhost));
    if ((hp = gethostbyname(myhost)) != NULL &&
	hp->h_name != NULL && *hp->h_name != '\0')
	strcpy(myhost, hp->h_name);
    host = user = display = NULL;
    port = "xtermd";
    while (argc > 0) {
	if (strcmp(argv[0], "-host") == 0) {
	    argv++; argc--;
	    if (argc == 0)
		quit(1, "%s: -host argument missing\n", progname);
	    host = *argv++; argc--;
	    continue;
	}
	if (strcmp(argv[0], "-user") == 0) {
	    argv++; argc--;
	    if (argc == 0)
		quit(1, "%s: -user argument missing\n", progname);
	    user = *argv++; argc--;
	    continue;
	}
	if (strcmp(argv[0], "-display") == 0) {
	    argv++; argc--;
	    if (argc == 0)
		quit(1, "%s: -display argument missing\n", progname);
	    display = *argv++; argc--;
	    continue;
	}
	if (strcmp(argv[0], "-port") == 0) {
	    argv++; argc--;
	    if (argc == 0)
		quit(1, "%s: -port argument missing\n", progname);
	    port = *argv++; argc--;
	    continue;
	}
	if (strcmp(argv[0], "--") == 0) {
	    argv++; argc--;
	}
	break;
    }
    if (host == NULL || *host == '\0') {
	getstr("Host?", myhost, hostbuff);
	host = hostbuff;
	if (host == NULL || *host == '\0')
	    quit(1, "%s: no host specified\n", progname);
    }
    if (user == NULL || *user == '\0') {
	user = getlogin();
	if (user == NULL || *user == '\0')
	    user = getenv("USER");
	if (user == NULL || *user == '\0')
	    if ((pw = getpwuid((int) getuid())) == NULL)
		user = "";
	    else
		user = pw->pw_name;
	getstr("User?", user, userbuff);
	user = userbuff;
	if (user == NULL || *user == '\0')
	    quit(1, "%s: no user specified\n", progname);
    }
    if (display == NULL || *display == '\0') {
	display = getenv("DISPLAY");
	if (display == NULL || *display == '\0') {
	    (void) sprintf(buff, "%s:0", myhost);
	    getstr("Display?", buff, dispbuff);
	    display = dispbuff;
	}
	if (display == NULL || *display == '\0')
	    quit(1, "%s: no display specified\n", progname);
	if (*display == ':') {
	    (void) strcpy(buff, display);
	    (void) sprintf(dispbuff, "%s%s", myhost, buff);
	    display = dispbuff;
	}
	if (strncasecmp(display, "unix:", 5) == 0) {
	    (void) strcpy(buff, display + 4);
	    (void) sprintf(dispbuff, "%s%s", myhost, buff);
	    display = dispbuff;
	}
	/* more display checks */
    }
    hp = gethostbyname(host);
    if (hp == NULL) {
	static struct hostent def;
	static struct in_addr defaddr;
	static char *alist[2] = { 0, 0 };
	static char namebuf[128];

	defaddr.s_addr = inet_addr(host);
	if (defaddr.s_addr == -1)
	    quit(1, "%s: unknown host: %s\n", progname, host);
	(void) strcpy(namebuf, host);
	def.h_name = namebuf;
	def.h_addr_list = alist, def.h_addr = (char *)&defaddr;
	def.h_length = sizeof(struct in_addr);
	def.h_addrtype = AF_INET;
	def.h_aliases = 0;
	hp = &def;
    }
    if (ulstrcmp(myhost, hp->h_name) != 0) {
	xhost = pathof("xlogin.xhost");
	if (xhost != NULL)
	    run(xhost, "xhost", hp->h_name, 0);
	else
	    fprintf(stderr, "%s: unable to find path of xhost\n", progname);
    }
    sin.sin_family = hp->h_addrtype;
    bcopy(hp->h_addr, (char *)&sin.sin_addr, hp->h_length);
    if (isdigit(*port))
	sin.sin_port = htons(atoi(port));
    else {
	sp = getservbyname(port, "tcp");
	if (sp == 0)
	    quit(1, "%s: unknown service: tcp/xtermd\n", progname);
	sin.sin_port = sp->s_port;
    }
    s = socket(hp->h_addrtype, SOCK_STREAM, 0);
    if (s < 0)
	quit(1, "%s: socket: %s\n", progname, errmsg(-1));
    if (connect(s, &sin, sizeof(sin)) < 0)
	quit(1, "%s: connect: %s\n", progname, errmsg(-1));
    (void) sprintf(buff, "%s %s\r\n", user, display);
    (void) write(s, buff, strlen(buff));
    f = fdopen(s, "r");
    lastc = EOF;
    while ((c = getc(f)) != EOF) {
	/* just strip parity */
	c &= 0177;
	lastc = c;
	if (c == '\r') continue;
	if (isprint(c) || isspace(c))
	    (void) putchar(c);
	else
	    (void) putchar(c ^ 0100);
    }
    if (lastc != EOF && lastc != '\n')
	(void) putchar('\n');
    (void) fclose(f);
    exit(0);
}
