#include <stdio.h>
#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/signal.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/errno.h>
#if	CMUCS
#include <sys/ttyloc.h>
#endif	CMUCS
#include <netinet/in.h>
#include <syslog.h>
#include <libc.h>
#include <pwd.h>

char dispbuf[128] = "DISPLAY=";
char homebuf[128] = "HOME=";
char *nenviron[]  = {
	"XTERMD=",
	"TERM=xterm",
	dispbuf,
	homebuf,
	NULL
};
extern char **environ, *pathof();
extern int errno;

#define	BANNER	"\r\n\r\n4.3 BSD UNIX (%s)\r\n\r\r\n\r"

main(argc, argv)
int argc;
char *argv[];
{
	int i, p, t;
	struct sgttyb b;
	long WindowId;
	register char *sp;
	char *ptr, *line;
	char hostname[MAXHOSTNAMELEN];
	char buffer[BUFSIZ];
	char args[BUFSIZ];
	struct sockaddr_in sin;
#if	CMUCS
	struct ttyloc ttyloc;
#endif	CMUCS
	char *service, *user, *shell, *display;
	struct passwd *pw;
	char *xtermpath, *host;
	int c;
	char defent[BUFSIZ];
	char defstrs[BUFSIZ];
	char *HE;
	char *HN;
	char *IM;
	char *inet_ntoa(), *getusershell();

	openlog("xtermd", LOG_PID, LOG_DAEMON);
	i = sizeof(sin);
	if (getpeername(0, &sin, &i) < 0)
		fatalperror(1, "getpeername", -1);
	host = inet_ntoa(sin.sin_addr);
	syslog(LOG_INFO, "Connection made from %s %#x",
		host, ntohs(sin.sin_port));
	if (gethostname(hostname, sizeof(hostname)) < 0)
		strcpy(hostname, "xtermd");
	xtermpath = pathof("xtermd.xterm");
	if (xtermpath == NULL)
		fatal(1, "No xterm path");
	bzero(args, sizeof(args));
	sp = args;
	do {
		i = &args[sizeof(args)-1] - sp;
		if (i <= 0)
		    fatal(1, "input args too long");
		i = read(0, sp, i);
		if (i < 0)
			fatalperror(1, "read", -1);
		else if (i == 0)
			fatal(1, "read (eof)");
		sp += i;
	} while (index(args, '\n') == 0);
	if ((sp = index(args, '\n')) != NULL) {
		*sp-- = '\0';
		if (sp > args && *sp == '\r')
			*sp = '\0';
	}
	ptr = args;
	user = nxtarg(&ptr, " \t");
	if ((pw = getpwnam(user)) == NULL)
		fatal(1, "User not found");
	setusershell();
	while ((shell = (char *)getusershell()) != NULL)
		if (strcmp(shell, pw->pw_shell) == 0)
			break;
	endusershell();
	if (shell == NULL)
		fatal(1, "Invalid shell");
	if (chdir(pw->pw_dir) < 0) {
		if (chdir("/tmp") < 0)
			fatalperror(1, "chdir(/tmp)", -1);
		nenviron[3] = NULL;
	} else
		(void) strcpy(homebuf+5, pw->pw_dir);
	display = nxtarg(&ptr, " \t");
	if (*display == '\0')
		fatal(1, "No display specified");
	(void) strcpy(dispbuf+8, display);
	for (c = 'p'; c <= 's'; c++) {
		struct stat stb;

		line = "/dev/ptyXX";
		line[8] = c;
		line[9] = '0';
		if (stat(line, &stb) < 0)
			break;
		for (i = 0; i < 16; i++) {
			line[9] = "0123456789abcdef"[i];
			p = open(line, O_RDWR, 0);
			if (p > 0)
				goto gotpty;
		}
	}
	fatal(1, "All network ports in use");
	/*NOTREACHED*/
gotpty:
	if (p != 3) {
		(void) dup2(p, 3);
		(void) close(p);
		p = 3;
	}
	for (t = getdtablesize()-1; t > 4; t--)
		(void) close(t);
	(void) close(0);
#if	CMUCS
	ttyloc.tlc_hostid = ntohl(sin.sin_addr.s_addr);
	ttyloc.tlc_ttyid = TLC_UNKTTY;
	(void) ioctl(p, TIOCSLOC, &ttyloc);
#endif	CMUCS
	t = open("/dev/tty", O_RDWR, 0);
	if (t >= 0) {
		(void) ioctl(t, TIOCNOTTY, 0);
		(void) close(t);
	}
	line[5] = 't';
	(void) chown(line, 0, 0);
	(void) chmod(line, 0622);
	if (open(line, O_RDWR, 0) < 0)
		exit(4);
	(void) signal(SIGHUP, SIG_IGN);
	vhangup();
	(void) setpgrp(0, 0);
	(void) signal(SIGHUP, SIG_DFL);
	(void) close(0);
	(void) open(line, O_RDWR, 0);
	(void) dup2(0, 1);
	(void) dup2(0, 2);
	if ((i = dfork()) < 0)
		exit(5);
	if (i == 0) {
		if (read(0, (char *)&WindowId, sizeof(long)) != sizeof(long))
			exit(7);
		(void) ioctl(0, TIOCGETP, (char *)&b);
		b.sg_flags = CRMOD|XTABS|ANYP|ECHO;
		(void) ioctl(0, TIOCSETP, (char *)&b);
		(void) close(p);

		/*
		 * Show banner that getty never gave.
		 */
		if (getent(defent, "default") == 1) {
			char *getstr();
			char *p = defstrs;

			HE = getstr("he", &p);
			HN = getstr("hn", &p);
			IM = getstr("im", &p);
			if (HN && *HN)
				strcpy(hostname, HN);
			edithost(HE, hostname);
			buffer[0] = '\0';
			if (IM && *IM)
				putf(IM, buffer, line);
		} else
			(void) sprintf(buffer, BANNER, hostname);
		(void) write(0, buffer, strlen(buffer));
		nenviron[3] = NULL;
		environ = nenviron;
		execl("/bin/login", "login", "-h", host, "-p", 0);
		exit(0);
		/*NOTREACHED*/
	}
	if (setgid(pw->pw_gid) < 0)
		fatalperror(1, "setgid", -1);
	if (setuid(pw->pw_uid) < 0)
		fatalperror(1, "setuid", -1);
	(void) close(0);
	(void) open("/dev/null", O_RDWR, 0);
	(void) dup2(0, 1);
	(void) dup2(0, 2);
	(void) sprintf(buffer,
			"exec %s -S%c%c3 -n \"%s login\" -display %s %s",
			xtermpath, line[8], line[9], hostname, display, ptr);
	environ = nenviron;
	execl("/bin/sh", "sh", "-c", buffer, 0);
	exit(0);
	/*NOTREACHED*/
}

fatal(f, msg)
	int f;
	char *msg;
{
	char buf[BUFSIZ];

	(void) sprintf(buf, "xtermd: %s\r\n", msg);
	(void) write(f, buf, strlen(buf));
	exit(0);
}

fatalperror(f, msg, errno)
	int f;
	char *msg;
	int errno;
{
	char buf[BUFSIZ];
	extern char *sys_errlist[];

	(void) sprintf(buf, "%s: %s", msg, errmsg(errno));
	fatal(f, buf);
}

char	editedhost[32];

edithost(pat, host)
	register char *pat;
	register char *host;
{
	register char *res = editedhost;

	if (!pat)
		pat = "";
	while (*pat) {
		switch (*pat) {

		case '#':
			if (*host)
				host++;
			break;

		case '@':
			if (*host)
				*res++ = *host++;
			break;

		default:
			*res++ = *pat;
			break;

		}
		if (res == &editedhost[sizeof editedhost - 1]) {
			*res = '\0';
			return;
		}
		pat++;
	}
	if (*host)
		strncpy(res, host, sizeof editedhost - (res - editedhost) - 1);
	else
		*res = '\0';
	editedhost[sizeof editedhost - 1] = '\0';
}

static char *putlocation;

puts(s)
register char *s;
{

	while (*s)
		putchr(*s++);
}

putchr(cc)
{
	*putlocation++ = cc;
}

putf(cp, where, line)
register char *cp;
char *where, *line;
{
	char *slash;
	char datebuffer[60];
	extern char *rindex();

	putlocation = where;

	while (*cp) {
		if (*cp != '%') {
			putchr(*cp++);
			continue;
		}
		switch (*++cp) {

		case 't':
			slash = rindex(line, '/');
			if (slash == (char *) 0)
				puts(line);
			else
				puts(&slash[1]);
			break;

		case 'h':
			puts(editedhost);
			break;

		case 'd':
			get_date(datebuffer);
			puts(datebuffer);
			break;

		case '%':
			putchr('%');
			break;
		}
		cp++;
	}
}
